--Spider Solitaire
--By DanTheLegoMan March 2010
--Version 1.0

--initialization
t = os.date('*t')
math.randomseed(os.time(t));
math.random(1);

cards = {{value=1 ,suit=1,img=image.load("1h.png") ,used=0},
		 {value=2 ,suit=1,img=image.load("2h.png") ,used=0},
		 {value=3 ,suit=1,img=image.load("3h.png") ,used=0},
		 {value=4 ,suit=1,img=image.load("4h.png") ,used=0},
		 {value=5 ,suit=1,img=image.load("5h.png") ,used=0},
		 {value=6 ,suit=1,img=image.load("6h.png") ,used=0},
		 {value=7 ,suit=1,img=image.load("7h.png") ,used=0},
		 {value=8 ,suit=1,img=image.load("8h.png") ,used=0},
		 {value=9 ,suit=1,img=image.load("9h.png") ,used=0},
		 {value=10,suit=1,img=image.load("10h.png"),used=0},
 		 {value=11,suit=1,img=image.load("11h.png"),used=0},
		 {value=12,suit=1,img=image.load("12h.png"),used=0},
		 {value=13,suit=1,img=image.load("13h.png"),used=0},
		 {value=1 ,suit=2,img=image.load("1c.png") ,used=0},
		 {value=2 ,suit=2,img=image.load("2c.png") ,used=0},
		 {value=3 ,suit=2,img=image.load("3c.png") ,used=0},
		 {value=4 ,suit=2,img=image.load("4c.png") ,used=0},
		 {value=5 ,suit=2,img=image.load("5c.png") ,used=0},
		 {value=6 ,suit=2,img=image.load("6c.png") ,used=0},
		 {value=7 ,suit=2,img=image.load("7c.png") ,used=0},
		 {value=8 ,suit=2,img=image.load("8c.png") ,used=0},
		 {value=9 ,suit=2,img=image.load("9c.png") ,used=0},
		 {value=10,suit=2,img=image.load("10c.png"),used=0},
 		 {value=11,suit=2,img=image.load("11c.png"),used=0},
		 {value=12,suit=2,img=image.load("12c.png"),used=0},
		 {value=13,suit=2,img=image.load("13c.png"),used=0},
		 {value=1 ,suit=3,img=image.load("1d.png") ,used=0},
		 {value=2 ,suit=3,img=image.load("2d.png") ,used=0},
		 {value=3 ,suit=3,img=image.load("3d.png") ,used=0},
		 {value=4 ,suit=3,img=image.load("4d.png") ,used=0},
		 {value=5 ,suit=3,img=image.load("5d.png") ,used=0},
		 {value=6 ,suit=3,img=image.load("6d.png") ,used=0},
		 {value=7 ,suit=3,img=image.load("7d.png") ,used=0},
		 {value=8 ,suit=3,img=image.load("8d.png") ,used=0},
		 {value=9 ,suit=3,img=image.load("9d.png") ,used=0},
		 {value=10,suit=3,img=image.load("10d.png"),used=0},
 		 {value=11,suit=3,img=image.load("11d.png"),used=0},
		 {value=12,suit=3,img=image.load("12d.png"),used=0},
		 {value=13,suit=3,img=image.load("13d.png"),used=0},
		 {value=1 ,suit=4,img=image.load("1s.png") ,used=0},
		 {value=2 ,suit=4,img=image.load("2s.png") ,used=0},
		 {value=3 ,suit=4,img=image.load("3s.png") ,used=0},
		 {value=4 ,suit=4,img=image.load("4s.png") ,used=0},
		 {value=5 ,suit=4,img=image.load("5s.png") ,used=0},
		 {value=6 ,suit=4,img=image.load("6s.png") ,used=0},
		 {value=7 ,suit=4,img=image.load("7s.png") ,used=0},
		 {value=8 ,suit=4,img=image.load("8s.png") ,used=0},
		 {value=9 ,suit=4,img=image.load("9s.png") ,used=0},
		 {value=10,suit=4,img=image.load("10s.png"),used=0},
 		 {value=11,suit=4,img=image.load("11s.png"),used=0},
		 {value=12,suit=4,img=image.load("12s.png"),used=0},
		 {value=13,suit=4,img=image.load("13s.png"),used=0} }

backImg = image.load("back.png");
emptyImg = image.load("emptyDeck.png");

sheight = screen.height()
swidth= screen.width()
green = color.new(0,100,0)
white = color.new(255,255,255)
black = color.new(0,0,0)
cardWidth = 32;
cardHeight = 50

-- draggingFrom can be a stack index (1 to 10)
draggingFrom = 0
dragX = 0
dragY = 0
dragXOffset = 0
dragYOffset = 0
dragCards = {}
deckCards = {}
quit = false;
home = { }
stacks = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {} }
stacksGap = { 17, 17, 17, 17, 17, 17, 17, 17, 17, 17 }
visible = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
hidden =  { 5, 5, 5, 5, 4, 4, 4, 4, 4, 4 }
moveHistory = {}
dealt = 0
win = 0
lose = 0;
mainMenu = 1
pauseMenu = 0
startTime = 0
endTime = 0
turns = 0
dragGap = 17
gameType = 1	-- 1 (one suit), 2 (two suits), 3 (four suits)
deckX = 364
deckY = 185

--get stats
wins = { 0,0,0 }
loses = { 0,0,0 }
bestTimes = { 99999999,99999999, 99999999 }

fStats = io.open("stats.lua")
if (fStats ~= nil) then
	for i = 1, 3 do
		input = fStats:read("*l")
		if (input ~= nil) then
			wins[i] = tonumber(input)
		end
		input = fStats:read("*l")
		if (input ~= nil) then
			loses[i] = tonumber(input)
		end
		input = fStats:read("*l")
		if (input ~= nil) then
			bestTimes[i] = tonumber(input)
		end
	end
	fStats:close()
end

function inRect(a,b,x,y,w,h)
	if (a >= x) and (a <= (x+w)) and (b >= y) and (b <= (y + h)) then
		return true
	end
	return false
end

function saveStats()
	fStats = io.open("stats.lua","w")
	if (fStats ~= nil) then
		for i = 1, 3 do
			fStats:write(wins[i],"\n")
			fStats:write(loses[i],"\n")
			fStats:write(bestTimes[i],"\n")
		end
		fStats:close()
	end
end

function isSaveGame()
	valid = false
	fSave = io.open("save.lua")
	if (fSave ~= nil) then
		input = fSave:read("*l")
		if (input ~= nil) and (string.find(input, "Spider Solitaire Save Game") ~= nil) then
			valid = true
		end
		fSave:close()
	end
	return valid
end

function saveGame()
	fSave = io.open("save.lua","w")
	if (fSave ~= nil) then
		fSave:write("Spider Solitaire Save Game\n")
		--Game Type
		fSave:write(gameType,"\n")
		--Home Piles
		fSave:write(table.concat(home," "),"\n")
		--Stacks
		for i = 1, 10 do
			fSave:write(hidden[i]," ",visible[i]," ",table.concat(stacks[i]," "),"\n")
		end
		--Deck cards
		fSave:write(table.concat(deckCards," "),"\n")
		--Number of turns
		fSave:write(turns,"\n")
		--Time taken so far
		fSave:write((os.time() - startTime),"\n")
		fSave:close()
	end
end

function loadGame()
	valid = false
	fSave = io.open("save.lua")
	if (fSave ~= nil) then
		input = fSave:read("*l")
		if (input ~= nil) and (string.find(input, "Spider Solitaire Save Game") ~= nil) then
			valid = true

			--reset variables
			home = {}
			for i = 1, 10 do
				visible[i] = 0
				hidden[i] = 0
			end
			win = 0;
			lose = 0;
			mainMenu = 0;
			pauseMenu = 0;
			turns = 0;
			stacks = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {} }
			deckCards = {};
			dragCards = {};

			--Read in game type
			input = fSave:read("*l")
			if (input ~= nil) then
				gameType = tonumber(input)
				if (gameType < 1) or (gameType > 3) then
					valid = false
				end
			end
			
			--Read in home piles
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					home[index] = tonumber(number);
					index = index + 1;
				end
			else
				valid = false
			end

			--Read in stacks
			for i = 1, 10 do
				input = fSave:read("*l")
				if (input ~= nil) then
					index = -1
					for number in string.gmatch(input,"%d+") do
						if (index == -1) then
							hidden[i] = tonumber(number)
						elseif (index == 0) then
							visible[i] = tonumber(number)
						else
							stacks[i][index] = tonumber(number)
						end
						index = index + 1
					end
				else
					valid = false
					break;
				end
			end
			
			--Read in Deck Cards
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					deckCards[index] = tonumber(number)
					index = index + 1
				end
			else
				valid = false
			end
						
			--Read in turns taken
			input = fSave:read("*l")
			if (input ~= nil) then
				turns = tonumber(input)
			end
			
			--Read in time taken so far
			timeTakenSoFar = 0
			input = fSave:read("*l")
			if (input ~= nil) then
				timeTakenSoFar = tonumber(input)
			end
			
			startTime = os.time() - timeTakenSoFar;
		end
		fSave:close()
	end
	
	--Delete the save file now
	fSave = io.open("save.lua","w")
	if (fSave ~= nil) then
		fSave:write("\n")
		fSave:close()
	end
		
	if (valid == false) then
		--Bad save game file!
		deal();
	else
		for i = 1, 10 do
			checkStackGap(i)
		end
	end
end

function getRandomCard()
	index = math.random(104-dealt)
	count = 1
	
	if (gameType == 1) then
		-- Spades only - each will need to be dealt 8 times
		sets = 8
		cardIndex = 40
	elseif (gameType == 2) then
		-- Spades and Diamonds only - each will need to be dealt 4 times
		sets = 4
		cardIndex = 27
	elseif (gameType == 3) then
		-- All the cards - each will need to be dealt twice
		sets = 2
		cardIndex = 1
	end
	
	for j = 1, sets do
		for i = cardIndex, 52 do
			if (cards[i].used < sets) then
				if (index == count) then
					cards[i].used = cards[i].used + 1;
					dealt = dealt + 1;
					return i;
				else
					count = count + 1
				end
			end
		end
	end

	return -1;
end

function getGameChoice()
	screen.fillrect(0,0,swidth,sheight,green);
	
	--Draw the Aces in the corners
	cards[1].img:draw(5,5);
	cards[14].img:draw(swidth-cardWidth-5,5)
	cards[27].img:draw(5,sheight-cardHeight-5)
	cards[40].img:draw(swidth-cardWidth-5,sheight-cardHeight-5)
	
	ots = text.size(18)
	otc = text.color(white);
	
	screen.fillrect(130,50,140,30,white)
	screen.fillrect(132,52,136,26,green)
	screen.fillrect(130,100,140,30,white)
	screen.fillrect(132,102,136,26,green)
	screen.fillrect(130,150,140,30,white)
	screen.fillrect(132,152,136,26,green)
	text.draw(130,55,"One Suit","center",270)
	text.draw(130,105,"Two Suits","center",270);
	text.draw(130,155,"Four Suits","center",270);
	screen.update()
	while (1) do
		if (control.read()==1) and (control.isTouch()==1) and (touch.click() == 1) then
			x,y = touch.pos()
			if (x >= 130) and (x <= 270) then
				if (y >= 50) and (y <= 80) then
					gameType = 1
					break
				elseif (y >= 100) and (y <= 130) then
					gameType = 2
					break
				elseif (y >= 150) and (y <= 180) then
					gameType = 3
					break
				end
			end
		end
		os.sleep(10)
	end
	
end

function deal()
	--reset stack totals
	for i = 1, 10 do
		visible[i] = 0
		hidden[i] = 0
	end
	--reset cards
	win = 0;
	lose = 0;
	mainMenu = 0;
	pauseMenu = 0;
	turns = 0;
	dealt = 0;
	for i = 1, 52 do
		cards[i].used = 0
	end
	home = {}

	getGameChoice()

	--Deal the cards in the play area
	stacks = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {} }
	for i = 1, 10 do
		if (i < 5) then
			count = 6
		else
			count = 5
		end
		for j = 1, count do
			stacks[i][j] = getRandomCard();
		end
	end
	
	deckCards = {};
	dragCards = {};
	
	for row = 1, 6 do
		if (row < 5) then
			for column = 1, 10 do
				hidden[column] = hidden[column] + 1
				drawScreen()
			end
		elseif (row < 6) then
			for column = 1, 10 do
				if (column < 5) then
					hidden[column] = hidden[column] + 1
				else
					visible[column] = visible[column] + 1
				end
				drawScreen()
			end
		else
			for column = 1, 4 do
				visible[column] = visible[column] + 1
				drawScreen()
			end
		end
		screen.backlight(100)
	end
	
	count = 104 - dealt;
	for i = 1, count do
		deckCards[i] = getRandomCard()
	end
	startTime = os.time();
end

function drawScreen()
	screen.fillrect(0,0,swidth,sheight,green);
	
	if ((win + lose + mainMenu + pauseMenu) == 0) then
		
		--Game
		for i = 1, 10 do
			x = 4 + ((i-1)*36);
			if (hidden[i] > 0) then
				for j = 1, hidden[i] do
					backImg:draw(x, 5 + ((j-1) * 4))
				end
			end
			if (visible[i] > 0) then
				for k = 1, visible[i] do
					cards[stacks[i][hidden[i]+k]].img:draw(x, 5 + (hidden[i] * 4) + ((k-1) * stacksGap[i]))
				end
			end
			if ((hidden[i] + visible[i]) == 0) then
				emptyImg:draw(x,5);
			end
		end
		
		--Deck
		if (#deckCards > 0) then
			backImg:draw(deckX, deckY);
		else
			emptyImg:draw(deckX, deckY);
		end
		
		--Home
		if (#home > 0) then
			x = deckX
			y = 28
			for i = 1, #home do
				cards[home[i]*13].img:draw(x,y)
				y = y + 15
			end
		end
		
		if (draggingFrom > 0) then
			for i = 1, #dragCards do
				cards[dragCards[i]].img:draw(dragX-dragXOffset,dragY-dragYOffset+((i-1)*dragGap));
			end
		end
	else
		ots = text.size(18)
		otc = text.color(white);

		--Draw the Aces in the corners
		cards[1].img:draw(5,5);
		cards[14].img:draw(swidth-cardWidth-5,5)
		cards[27].img:draw(5,sheight-cardHeight-5)
		cards[40].img:draw(swidth-cardWidth-5,sheight-cardHeight-5)
		if (win == 1) then
			--NOTE Should really use os.difftime - but that doesn't appear to work on the Zen X-Fi 2
			timeTaken = endTime - startTime
			if (timeTaken == bestTimes[gameType]) then
				text.draw(0,10,"Best Time!","center",400)
			else
				text.draw(0,10,"Winner!","center",400)
			end
			text.draw(0,30,"Time : "..timeTaken.." seconds","center",400)
		elseif (lose == 1) then
			text.draw(0,30,"No Moves Left!","center",400)
		elseif (mainMenu == 1) then
			if (isSaveGame()) then
				-- Add 'Load Game' Button
				screen.fillrect(130,80,140,30,white)
				screen.fillrect(132,82,136,26,green)
				text.draw(130,85,"Load Game","center",270)
			end
		elseif (pauseMenu == 1) then
			-- Add 'Return', 'Save And Quit'
			screen.fillrect(130,40,140,30,white)
			screen.fillrect(132,42,136,26,green)
			text.draw(130,45,"Return","center",270)
			screen.fillrect(130,80,140,30,white)
			screen.fillrect(132,82,136,26,green)
			text.draw(130,85,"Save And Quit","center",270)
		end
	
		--Draw 'New Game' and 'Quit' buttons
		screen.fillrect(130,120,140,30,white)
		screen.fillrect(132,122,136,26,green)
		screen.fillrect(130,160,140,30,white)
		screen.fillrect(132,162,136,26,green)
		text.draw(130,125,"New Game","center",270)
		text.draw(130,165,"Quit","center",270);
		
		if (wins[gameType] ~= 0) or (loses[gameType] ~= 0) then
			text.size(14)
			text.draw(30,100,"Wins "..wins[gameType],"center",100)
			text.draw(30,130,"Loses "..loses[gameType],"center",100)
			if (wins[gameType] ~= 0) then
				text.draw(300,100,"Best Time","center",370)
				text.draw(300,130,""..bestTimes[gameType].." secs","center",370)
			end
		end
		
		--Credits and Version
		text.size(12);
		text.draw(0,200,"Version 1.0","center",400);
		text.draw(0,220,"By DanTheLegoMan","center",400);
		
		text.size(ots)
		text.color(otc);
	end

	screen.update()
end

function checkStackGap(i)
	-- Determine if stack i is too big to fit on the screen
	local maxHeight = sheight - 10
	local height = (hidden[i] * 4) + ((visible[i]-1)*17) + cardHeight
	if (height > maxHeight) then
		-- Need to decrease stacksGap[i] to make room
		stacksGap[i] = math.floor((maxHeight - (hidden[i]*4) - cardHeight) / (visible[i]-1))
	else
		stacksGap[i] = 17
	end	
end

function checkForWin()
	if (#home == 8) then
		win = 1;
		endTime = os.time();
		if ((endTime - startTime) < bestTimes[gameType]) then
			bestTimes[gameType] = endTime - startTime
		end
		wins[gameType] = wins[gameType] + 1
		saveStats()
	end
end

-- Get the number of cards in sequence starting from the bottom card of the given stack index
function getNumCardsInSequenceFromBottom(i)
	local lastCard = hidden[i]+visible[i]
	local count = 0
	if (lastCard > 0) then
		suit = cards[stacks[i][lastCard]].suit
		value = cards[stacks[i][lastCard]].value
		count = 1
		while (count < visible[i]) do
			if (suit == cards[stacks[i][lastCard - count]].suit) and
				((value+count) == cards[stacks[i][lastCard - count]].value) then
			   count = count + 1
			else
				break;
			end
		end
	end
	return count
end

-- Get the number of cards in value order (not necessarily same suit) starting from the bottom card of the given stack index
function getNumCardsInValueSequenceFromBottom(i)
	local lastCard = hidden[i]+visible[i]
	local count = 0
	if (lastCard > 0) then
		value = cards[stacks[i][lastCard]].value
		count = 1
		while (count < visible[i]) do
			if ((value+count) == cards[stacks[i][lastCard - count]].value) then
			   count = count + 1
			else
				break;
			end
		end
	end
	return count
end

--Move 'num' cards from the bottom of 'from' stack to the bottom of 'to' stack
function moveCards(numCards,fromStack,toStack)
	fromIndex = #stacks[fromStack]-numCards
	for i = 1, numCards do
		tmp = #stacks[toStack]
		stacks[toStack][tmp+1] = stacks[fromStack][fromIndex+i]
	end
	visible[toStack] = visible[toStack] + numCards
	
	for i = 1, numCards do
		table.remove(stacks[fromStack])
	end
	visible[fromStack] = visible[fromStack] - numCards
end

function anyMoves()
		
	for i = 1, 10 do
		if (hidden[i]+visible[i] == 0) then
			return true
		end
	end
	
	-- Get the number of cards in the correct sequence at the bottom of each of the stacks
	local cardsInSequence = {}
	local cardsInValueSequence = {}
	
	for i = 1, 10 do
		cardsInSequence[i] = getNumCardsInSequenceFromBottom(i)
		cardsInValueSequence[i] = getNumCardsInValueSequenceFromBottom(i)
	end
	
	for i = 1, 10 do
		if (cardsInSequence[i] > 0) then
			lastCard = hidden[i]+visible[i]
			
			for j = lastCard-cardsInSequence[i]+1, lastCard do
				local toMove = lastCard-j+1
				for k = 1, 10 do
					if (k ~= i) then
						-- Can card 'j' from stack 'i' move to the bottom of stack 'k'?
						if (hidden[k]+visible[k] > 0) then
							if (cards[stacks[i][j]].value == (cards[stacks[k][hidden[k]+visible[k]]].value - 1)) then
								
								-- If we find the same or the opposite move in the move history, skip it to prevent infinite recursion
								newMove = 1
								for move = 1, #moveHistory do
									if (moveHistory[move].fromIndex == (hidden[k]+visible[k]+1)) and (moveHistory[move].fromStack == k) and
									   (moveHistory[move].toIndex == j) and (moveHistory[move].toStack == i) then
									   newMove = 0
									elseif (moveHistory[move].fromIndex == j) and (moveHistory[move].fromStack == i) and
									   (moveHistory[move].toIndex == (hidden[k]+visible[k]+1)) and (moveHistory[move].toStack == k) then
									   newMove = 0
									end
								end
							
								if (newMove == 1) then
									-- Is this a 'good' move?
									if (cards[stacks[i][j]].suit == cards[stacks[k][hidden[k]+visible[k]]].suit) then
										count = cardsInSequence[k] + toMove
										if (count > cardsInSequence[i]) then
											-- This will increase the number of cards in a row so probably a good move
											return true
										end
									else
										-- As we are not moving the same suit, this is only a useful move if it
										-- results in a hidden card being revealed, or a stack becoming empty, or
										-- it results in a potential good move (recursive call to this function)
										if (hidden[i] == 0) and (j == 1) then
											-- Looks good - this will create an empty stack
											return true
										elseif (j == (hidden[i] + 1)) then
											-- Looks good - this will reveal a card
											return true
										elseif (j > 1) then
											-- Make sure we are not disrupting a sequence of cards
											if (cardsInSequence[i] == 1) or (cardsInSequence[i] == toMove) then
												-- Save History
												moveHistory[#moveHistory+1] = { fromIndex = j, fromStack = i, toIndex = (hidden[k]+visible[k]+1), toStack = k}
												-- Update the tables
												moveCards(toMove,i,k)
												result = anyMoves()
												--put the cards back
												moveCards(toMove,k,i)
												table.remove(moveHistory)
												if (result) then
													return true
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	
	return false
end

function checkForPossibleMoves()
	
	if (win == 0) and (#deckCards == 0) then
		moveHistory = {}
		if (anyMoves() == false) then
			lose = 1
			loses[gameType] = loses[gameType] + 1
			saveStats()
		end
		moveHistory = {}
	end
end

function checkDrag(x,y)
	if (y >= 5) then
		for i = 1, 10 do
			stackX = 4 + ((i-1)*36)
			if (visible[i] > 0) and (x >= stackX) and (x <= (stackX + cardWidth)) then
			
				--get boundaries of visible cards
				stackY = 5 + (hidden[i] * 4);
				stackHeight = ((visible[i]-1)*stacksGap[i]) + cardHeight;
				if (x >= stackX) and (x <= (stackX + cardWidth)) and (y >= stackY) and (y <= (stackY + stackHeight)) then
					y = y - stackY
					--get index of card that is being dragged
					index = hidden[i] + math.floor(y / stacksGap[i]) + 1
					if (index > #stacks[i]) then
						index = #stacks[i]
					end
					
					--check that every card below this card matches the suit and decreases in value
					suit = cards[stacks[i][index]].suit
					value = cards[stacks[i][index]].value
					draggable = true
					if (#stacks[i] > index) then
						for j = index+1, #stacks[i] do
							if (cards[stacks[i][j]].suit == suit) and (cards[stacks[i][j]].value == (value - 1)) then
								value = value - 1
							else
								draggable = false
								break
							end
						end
					end
					
					if (draggable == false) then
						break;
					end
					
					count = #stacks[i] - index + 1
					for j = 1, count do
						table.insert(dragCards,1,table.remove(stacks[i]))
					end
					visible[i] = visible[i] - count;
					draggingFrom = i
					dragXOffset = x - stackX
					dragYOffset = y - (stacksGap[i]*(index-hidden[i]-1))
					return
				end
			end
		end
	end
end

function returnDraggedCards()
	--return the cards from whence they came
	if (draggingFrom > 0) and (draggingFrom < 11) then
		count = #dragCards;
		for j = 1, count do
			stacks[draggingFrom][#stacks[draggingFrom]+1] = table.remove(dragCards, 1)
		end
		visible[draggingFrom] = visible[draggingFrom] + count;
	end
end

function checkForRuns(index)
	if (visible[index] >= 13) then
		suit = -1
		value = 13
		for i = 1, visible[index] do
			cardIndex = stacks[index][i+hidden[index]]
			if (cards[cardIndex].value == value) and ((suit == -1) or (cards[cardIndex].suit == suit)) then
				suit = cards[cardIndex].suit
				value = value - 1
				if (value == 0) then
					-- Found a run of 13 cards of the same suit!
					for j = 1, 13 do
						table.remove(stacks[index])
					end
					visible[index] = visible[index] - 13
					home[#home+1] = suit
					-- Check if we need to uncover a card now
					if (visible[index] == 0) and (hidden[index] > 0) then
						visible[index] = 1
						hidden[index] = hidden[index] - 1
					end
					-- Check if that was the last set of 13 cards
					checkForWin()
					break;
				end
			elseif (cards[cardIndex].value == 13) then
				suit = cards[cardIndex].suit
				value = 12
			else
				suit = -1
				value = 13
			end
			
		end
	end
end

function checkDragDrop(x,y)
	valid = -1;
	
	for i = 1, 10 do
		--Get boundaries of lowest card in stack
		stackX = 4 + ((i-1)*36);
		stackY = 5;
		if (hidden[i] > 1) then
			stackY = stackY + ((hidden[i]-1)*4)
		end
		if (visible[i] > 0) then
			if (hidden[i] > 0) then
				stackY = stackY + 4
			end
			stackY = stackY + ((visible[i]-1)*stacksGap[i])
		end
		
		if inRect(x,y,stackX,stackY,cardWidth,1.5*cardHeight) then

			--if stack is empty add dragged card(s) to the stack
			if (#stacks[i] == 0) then
				for j = 1, #dragCards do
					stacks[i][j] = dragCards[j];
				end
				visible[i] = visible[i] + #dragCards;
				valid = i
				break;
			end
			
			--if stack is not empty, has a visible card, and the top card being dragged is one less than
			--the bottom card in the stack, add the dragged card(s) to the stack
			if (#stacks[i] ~= 0) and (visible[i] > 0) and (cards[dragCards[1]].value == (cards[stacks[i][#stacks[i]]].value - 1)) then
				for j = 1, #dragCards do
					stacks[i][#stacks[i]+1] = dragCards[j];
				end
				visible[i] = visible[i] + #dragCards
				valid = i
				break;
			end
			
		end
	end
	
	if (valid ~= -1) then
		-- Check if the destination stack now has a run of 13 cards of the same suit
		if (visible[valid] >= 13) then
			suit = -1
			value = 13
			for i = 1, visible[valid] do
				cardIndex = stacks[valid][i+hidden[valid]]
				if (cards[cardIndex].value == value) and ((suit == -1) or (cards[cardIndex].suit == suit)) then
					suit = cards[cardIndex].suit
					value = value - 1
					if (value == 0) then
						-- Found a run of 13 cards of the same suit!
						for j = 1, 13 do
							table.remove(stacks[valid])
						end
						visible[valid] = visible[valid] - 13
						home[#home+1] = suit
						-- Check if we need to uncover a card now
						if (visible[valid] == 0) and (hidden[valid] > 0) then
							visible[valid] = 1
							hidden[valid] = hidden[valid] - 1
						end
						-- Check if that was the last set of 13 cards
						checkForWin()
						break;
					end
				elseif (cards[cardIndex].value == 13) then
					suit = cards[cardIndex].suit
					value = 12
				else
					suit = -1
					value = 13
				end
				
			end
		end
		
		checkStackGap(valid)
		
		-- If the stack being dragged from has one or more hidden cards and no visible cards
		-- then reveal the top hidden card
		if (visible[draggingFrom] == 0) and (hidden[draggingFrom] > 0) then
			visible[draggingFrom] = 1
			hidden[draggingFrom] = hidden[draggingFrom] - 1
		end
		
		checkStackGap(draggingFrom)
		
		turns = turns + 1
		
		checkForPossibleMoves()		
	else
		returnDraggedCards()
	end

	dragCards = {};
end

function checkClick(x,y)
	if (#deckCards>0) and (inRect(x,y,deckX,deckY,cardWidth,cardHeight)) then
		local empty = 0
		local total = 0
		for i = 1, 10 do
			if (#stacks[i] == 0) then
				empty = empty + 1
			else
				total = total + #stacks[i]
			end
		end
		if (empty <= (10 - math.min(10,total))) then
			-- Deal out the cards
			for i = 1, 10 do
				table.insert(stacks[i],table.remove(deckCards))
				visible[i] = visible[i] + 1
				if (visible[i] >= 13) then
					checkForRuns(i)
				end
				checkStackGap(i)
			end
			turns = turns + 1
			checkForPossibleMoves()
		end
	end
end

while (1) do
	for i = 0, 6 do
		if control.read()==1 then
			if control.isTouch()==1 then
				x,y = touch.pos()
				if (touch.move() == 1) then
					if (draggingFrom == 0) then
						checkDrag(dragX,dragY);
					else
						dragX = x;
						dragY = y;
					end
				elseif (touch.down() == 1) then
					dragX = x;
					dragY = y;
				elseif (touch.up() == 1) then
					if (draggingFrom > 0) then
						checkDragDrop(x,y);
						draggingFrom = 0;
					end
				elseif (touch.click() == 1) then
					if ((win + lose + mainMenu) > 0) then
						if (x >= 130) and (x <= 270) then
							if (y >= 80) and (y <= 110) and (mainMenu == 1) then
								loadGame()
							elseif (y >= 120) and (y <= 150) then
								deal();
							elseif (y >= 160) and (y <= 190) then
								quit = true;
								break;
							end
						end
					elseif (pauseMenu == 1) then
						if (x >= 130) and (x <= 270) then
							if (y >= 40) and (y <= 70) then
								-- "Return" button
								pauseMenu = 0
							elseif (y >= 80) and (y <= 110) then
								-- "Save and Quit" button
								saveGame()
								quit = true
							elseif (y >= 120) and (y <= 150) then
								-- "New Game" button
								if (turns > 0) then
									-- If player has moved at least one card then this counts as a lose ... mean I know!
									loses[gameType] = loses[gameType] + 1
									saveStats()
								end
								deal();
							elseif (y >= 160) and (y <= 190) then
								-- "Quit" button
								if (turns > 0) then
									-- If player has moved at least one card then this counts as a lose ... mean I know!
									loses[gameType] = loses[gameType] + 1
									saveStats()
								end
								quit = true;
								break;
							end
						end
					else
						checkClick(x,y);
					end
				end
			elseif control.isButton()==1 then
				if button.click() == 1 then
					if ((mainMenu + win + lose + pauseMenu) > 0) then
						quit = true
					else
						-- Make sure that if a drag operation is in progress we cancel it
						returnDraggedCards()
						dragCards = {};
						draggingFrom = 0;
						pauseMenu = 1;
					end
					break
				end
			end
		end
	end
	if (quit == true) then
		break;
	end
	drawScreen();
	screen.backlight(100)
	os.sleep(1)
end

backImg:close();
emptyImg:close();
for i = 1, 52 do
	cards[i].img:close();
end


